import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)
import(Module_Math)
import(Module_String)
import(Module_Package)
include("UtilRefs.lua")

SET_TIMER_GOING((12*60)*6, 1)

--4320 turns is the total game.
aliveShamans = {}
shamFindBools = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}

tribeKills = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}
deadShamans = {}
deadShamansIntArray = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}

strings_name_width = { [0]= 85, 85, 85, 85, 85, 85, 85, 85 };
initialized = 0
Font ={
	Large = P3_LARGE_FONT;
	Small = P3_SMALL_FONT_NORMAL;
}

Players = {
	[0]=
	{
		Color = CLR_BLUE,
		Name = "Blue"
	},
	{
		Color = CLR_RED,
		Name = "Red"
	},
	{
		Color = CLR_YELLOW,
		Name = "Yellow"
	},
	{
		Color = CLR_GREEN,
		Name = "Green"
	},
	{
		Color = CLR_TURQUOISE,
		Name = "Cyan"
	},
	{
		Color = CLR_DARK_PURPLE,
		Name = "Pink"
	},
	{
		Color = CLR_BLACK,
		Name = "Black"
	},
	{
		Color = 14,
		Name = "Orange"
	}
}

char_width = {
	["A"] = 10,
	["B"] = 9,
	["C"] = 12,
	["D"] = 11,
	["E"] = 8,
	["F"] = 8,
	["G"] = 12,
	["H"] = 10,
	["I"] = 4,
	["J"] = 4,
	["K"] = 10,
	["L"] = 8,
	["M"] = 14,
	["N"] = 10,
	["O"] = 14,
	["P"] = 9,
	["Q"] = 13,
	["R"] = 10,
	["S"] = 9,
	["T"] = 10,
	["U"] = 11,
	["V"] = 11,
	["W"] = 16,
	["X"] = 11,
	["Y"] = 12,
	["Z"] = 11,
	["["] = 7,
	["\\"] = 11,
	["]"] = 7,
	["_"] = 16,
	["'"] = 5,
	[" "] = 8,
	["!"] = 4,
	["\""] = 8,
	["#"] = 14,
	["$"] = 11,
	["%"] = 16,
	["&"] = 15,
	["("] = 6,
	[")"] = 6,
	["*"] = 9,
	["+"] = 10,
	[","] = 5,
	["-"] = 11,
	["."] = 4,
	["/"] = 11,
	["0"] = 11,
	["1"] = 4,
	["2"] = 11,
	["3"] = 11,
	["4"] = 11,
	["5"] = 11,
	["6"] = 11,
	["7"] = 11,
	["8"] = 12,
	["9"] = 11,
	[":"] = 4,
	[";"] = 4,
	["<"] = 7,
	["="] = 14,
	[">"] = 7,
	["?"] = 11,
	["@"] = 17,
};

finishedGame = 0

shenanigansNumber = 0

for i=0,7 do
  SET_NO_REINC(i)
end

local Reincarnations = {
	MAP_XZ_2_WORLD_XYZ(28, 46),
	MAP_XZ_2_WORLD_XYZ(228, 44),
	MAP_XZ_2_WORLD_XYZ(208, 26),
	MAP_XZ_2_WORLD_XYZ(208, 228),
	MAP_XZ_2_WORLD_XYZ(228, 208),
	MAP_XZ_2_WORLD_XYZ(26, 208),
	MAP_XZ_2_WORLD_XYZ(46, 228),
	MAP_XZ_2_WORLD_XYZ(46, 28)
}

local tribes = {}

for i, k in ipairs(Reincarnations) do
	local me = world_coord3d_to_map_ptr(k)
	me.MapWhoList:processList(function(t)
		if (t.Type == T_PERSON) then
			if (t.Model == M_PERSON_MEDICINE_MAN) then
				table.insert(tribes, t.Owner)
			end
		end
		return true
	end)
end

local Locations = {
  MAP_XZ_2_WORLD_XYZ(2, 0), --Centre 1
	MAP_XZ_2_WORLD_XYZ(0, 28), --North 2
	MAP_XZ_2_WORLD_XYZ(28, 254), -- East 3
	MAP_XZ_2_WORLD_XYZ(254, 224), -- South 4
	MAP_XZ_2_WORLD_XYZ(226, 2), --West 5
	MAP_XZ_2_WORLD_XYZ(242, 14), --NorthWest 6
	MAP_XZ_2_WORLD_XYZ(12, 14), --NorthEast 7
	MAP_XZ_2_WORLD_XYZ(12, 240), --SouthEast 8
	MAP_XZ_2_WORLD_XYZ(242, 240), --SouthWest 9
	MAP_XZ_2_WORLD_XYZ(2, 6), --CentreSpecial 10
	MAP_XZ_2_WORLD_XYZ(8, 0), --CentreSpecial 11
	MAP_XZ_2_WORLD_XYZ(2, 250), --CentreSpecial 12
	MAP_XZ_2_WORLD_XYZ(252, 0) --CentreSpecial 13
}

function OnTurn()
	if (initialized == 0) then
		initialized = 1
		for pn=0, 7,1 do
			Players[pn].Name = get_player_name(pn, true)
			CachePlayerNameWidth(Players[pn].Name, pn)
		end
	end

	--Give enough mana for blast please
	GIVE_MANA_TO_PLAYER(TRIBE_BLUE, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_RED, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_YELLOW, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_GREEN, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_CYAN, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_PINK, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_BLACK, 334)
	GIVE_MANA_TO_PLAYER(TRIBE_ORANGE, 334)

	--Shenanigans ;)
	if (everyPow(720, 1)) then
		if (shenanigansNumber == 0) then
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[6], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[7], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[8], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[9], false, false)
		end

		if (shenanigansNumber == 1) then
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[1], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[1], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[1], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[1], false, false)
		end

		if (shenanigansNumber == 2) then
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[5], false, false)
		end

		if (shenanigansNumber == 3) then
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[5], false, false)

			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[5], false, false)

			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[5], false, false)

			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[5], false, false)
		end

		if (shenanigansNumber == 4) then
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[1], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[1], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[10], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[11], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[12], false, false)
			createThing(T_EFFECT, M_EFFECT_HILL, TRIBE_NEUTRAL, Locations[13], false, false)

			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[2], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[3], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[4], false, false)
			createThing(T_EFFECT, M_EFFECT_RISE, TRIBE_NEUTRAL, Locations[5], false, false)

			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[6], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[7], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[8], false, false)
			createThing(T_EFFECT, M_EFFECT_DIP, TRIBE_NEUTRAL, Locations[9], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[6], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[7], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[8], false, false)
			createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, Locations[9], false, false)
		end

		shenanigansNumber = shenanigansNumber + 1
	end
	--Stop of Shenanigans

	if (everyPow(12, 1)) then
    for i, sham in pairs(aliveShamans) do
      if (sham ~= nil) then
        shamFindBools[sham.Owner] = 1
      end
    end

    for i=0, 7 do
      if (shamFindBools[i] == 0) then
        local sham  = getShaman(i)
        if (sham ~= nil) then
          table.insert(aliveShamans, sham)
        end
      end
    end

    shamFindBools = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}
  end

	if (everyPow(1, 1)) then
    for i, sham in pairs(aliveShamans) do
      if (sham ~= nil and finishedGame == 0) then
        if (sham.State == S_PERSON_DYING or sham.State == S_PERSON_DROWNING or sham.State == S_PERSON_ELECTROCUTED or sham.State == S_PERSON_SWAMP_DROWNING) then
					if (sham.u.Pers.u.Owned.LastDamagedBy ~= TRIBE_NEUTRAL) then
						tribeKills[sham.u.Pers.u.Owned.LastDamagedBy] = tribeKills[sham.u.Pers.u.Owned.LastDamagedBy] + 1
					end
					
          table.remove(aliveShamans, i)

					for i, tribe in pairs(tribes) do
						if (tribe == sham.Owner and finishedGame == 0) then
							TrySpawn(tribe)
						end
					end
        end
      end
    end
  end

	--If someone reaches 20 kills the game ends.
	if (everyPow(36, 1)) then
		for i=0, 7 do
			if (tribeKills[i] >= 20) then
				local winnerTribe = i
				finishedGame = 1

				ProcessGlobalTypeList(T_PERSON, function(t)
					if (t.Owner ~= winnerTribe) then
						damage_person(t, winnerTribe, 90000, 1)
					end
					return true
				end)
			end
		end
	end

	--After 6 minutes the game ends.
	if (GetTurn() >= 4320 and finishedGame == 0) then
		local max_kills = -999999999
		local allKills = {}
		local winner = -1
		finishedGame = 1

		for i=0, 7 do
			table.insert(allKills, tribeKills[i])
		end

		for i,value in ipairs(allKills) do
			if (value > max_kills) then
				max_kills = value
				winner = i-1
			end
		end

		ProcessGlobalTypeList(T_PERSON, function(t)
      if (t.Owner ~= winner) then
        damage_person(t, TRIBE_NEUTRAL, 90000, 1)
      end
    return true
    end)
	end
end

function TrySpawn(tribe)
	local spawnLocation = G_RANDOM(7) + 1
	local spawned = 0

	SearchMapCells(CIRCULAR, 0, 0, 8, world_coord3d_to_map_idx(Reincarnations[spawnLocation]), function(me)
		me.MapWhoList:processList(function(p)
			if (p.Type == T_PERSON) then
				if (p.Model == M_PERSON_MEDICINE_MAN) then
					spawned = 1
					return false
				end
			end
		return true
		end)
	return true
	end)

	if (spawned == 1) then
		TrySpawn(tribe)
	end

	if (spawned == 0) then
		createThing(T_PERSON, M_PERSON_MEDICINE_MAN, tribe, Reincarnations[spawnLocation], false, false)
	end
end

function OnCreateThing(t)
	if (t.Type == T_SPELL) then
		for i, reinc in pairs(Reincarnations) do
			if (get_world_dist_xyz(reinc, t.Pos.D3) <= 4300) then
				t.Model = M_SPELL_NONE
			end
		end
	end

	if (t.Type == T_EFFECT) then
		if (t.Model == M_EFFECT_SPELL_BLAST) then
			SearchMapCells(CIRCULAR, 0, 0, 0, world_coord3d_to_map_idx(t.Pos.D3), function(me)
				me.MapWhoList:processList(function(p)
					if (p.Type == T_SCENERY) then
						if (p.Model == M_SCENERY_TREE_1 or p.Model == M_SCENERY_TREE_2 or p.Model == M_SCENERY_TREE_3) then
							local heretic = getShaman(t.Owner)

							if (heretic ~= nil) then
								createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, heretic.Pos.D3, false, false)
							end
						end
					end
				return true
				end)
			return true
			end)
		end
	end
end


bar_w = 200
bar_h = 15
box_y_offset = 20
offset_incr = 30
names_offset = 40
function OnFrame()
	offset = 0
	for i=7, 0, -1 do
		PopSetFont(Font.Large)
		local scale = math.floor(ScreenHeight() * 0.01)
		local text_y_offset = 2 - math.ceil((bar_h/2)-2)
		DrawBox(ScreenWidth()-32-strings_name_width[i]-10, ScreenHeight()-box_y_offset-scale-offset, 25, bar_h+scale, Players[i].Color)
		LbDraw_Text(ScreenWidth()-strings_name_width[i] - 10, ScreenHeight()-box_y_offset-scale-text_y_offset-offset, Players[i].Name, 0)
		offset = offset + offset_incr
	end
end

function CachePlayerNameWidth(str, pn)
	local w = GetStringWidth(str)
	strings_name_width[pn] = w
end

function GetStringWidth(str)
	local w = 0;
	for i=1,#str,1 do
		local c = str:sub(i,i)
		c = string.upper(c);
		if (char_width[c] ~= nil) then
			w = w + char_width[c];
		else
			w = w + 10 + 2;
		end
	end
	return w;
end