import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)
import(Module_Math)
import(Module_String)
import(Module_Package)
include("UtilRefs.lua")

SET_TIMER_GOING((12*60)*6, 1)

--4320 turns is the total game.
aliveShamans = {}
shamFindBools = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}

angels = {}

tribeKills = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}
deadShamans = {}
deadShamansIntArray = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}

setUpDone = 0
finishedGame = 0

strings_name_width = { [0]= 85, 85, 85, 85, 85, 85, 85, 85 };
initialized = 0
Font ={
	Large = P3_LARGE_FONT;
	Small = P3_SMALL_FONT_NORMAL;
}

Players = {
	[0]=
	{
		Color = CLR_BLUE,
		Name = "Blue"
	},
	{
		Color = CLR_RED,
		Name = "Red"
	},
	{
		Color = CLR_YELLOW,
		Name = "Yellow"
	},
	{
		Color = CLR_GREEN,
		Name = "Green"
	},
	{
		Color = CLR_TURQUOISE,
		Name = "Cyan"
	},
	{
		Color = CLR_DARK_PURPLE,
		Name = "Pink"
	},
	{
		Color = CLR_BLACK,
		Name = "Black"
	},
	{
		Color = 14,
		Name = "Orange"
	}
}

char_width = {
	["A"] = 10,
	["B"] = 9,
	["C"] = 12,
	["D"] = 11,
	["E"] = 8,
	["F"] = 8,
	["G"] = 12,
	["H"] = 10,
	["I"] = 4,
	["J"] = 4,
	["K"] = 10,
	["L"] = 8,
	["M"] = 14,
	["N"] = 10,
	["O"] = 14,
	["P"] = 9,
	["Q"] = 13,
	["R"] = 10,
	["S"] = 9,
	["T"] = 10,
	["U"] = 11,
	["V"] = 11,
	["W"] = 16,
	["X"] = 11,
	["Y"] = 12,
	["Z"] = 11,
	["["] = 7,
	["\\"] = 11,
	["]"] = 7,
	["_"] = 16,
	["'"] = 5,
	[" "] = 8,
	["!"] = 4,
	["\""] = 8,
	["#"] = 14,
	["$"] = 11,
	["%"] = 16,
	["&"] = 15,
	["("] = 6,
	[")"] = 6,
	["*"] = 9,
	["+"] = 10,
	[","] = 5,
	["-"] = 11,
	["."] = 4,
	["/"] = 11,
	["0"] = 11,
	["1"] = 4,
	["2"] = 11,
	["3"] = 11,
	["4"] = 11,
	["5"] = 11,
	["6"] = 11,
	["7"] = 11,
	["8"] = 12,
	["9"] = 11,
	[":"] = 4,
	[";"] = 4,
	["<"] = 7,
	["="] = 14,
	[">"] = 7,
	["?"] = 11,
	["@"] = 17,
};

local LightningLocations = {}

for i=0,7 do
  SET_NO_REINC(i)
end

local Reincarnations = {
	MAP_XZ_2_WORLD_XYZ(206, 6),
	MAP_XZ_2_WORLD_XYZ(212, 228),
	MAP_XZ_2_WORLD_XYZ(236, 210),
	MAP_XZ_2_WORLD_XYZ(14, 206),
	MAP_XZ_2_WORLD_XYZ(48, 242),
	MAP_XZ_2_WORLD_XYZ(50, 14),
	MAP_XZ_2_WORLD_XYZ(16, 46),
	MAP_XZ_2_WORLD_XYZ(222, 42)
}

local tribes = {}

for i, k in ipairs(Reincarnations) do
	local me = world_coord3d_to_map_ptr(k)
	me.MapWhoList:processList(function(t)
		if (t.Type == T_PERSON) then
			if (t.Model == M_PERSON_MEDICINE_MAN) then
				table.insert(tribes, t.Owner)
			end
		end
		return true
	end)
end

function OnTurn()
	if (initialized == 0) then
		initialized = 1
		for pn=0, 7,1 do
			Players[pn].Name = get_player_name(pn, true)
			CachePlayerNameWidth(Players[pn].Name, pn)
		end
	end

	if (setUpDone == 0) then
		ProcessGlobalTypeList(T_SCENERY, function(t)
			if (t.Type == T_SCENERY) then
				if (t.Model == M_SCENERY_RS_PILLAR) then
					table.insert(LightningLocations, t)
				end
			end
		return true
		end)

		setUpDone = 1
	end

	--2200
	if (everyPow(2200, 1)) then
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_BLUE, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_RED, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_YELLOW, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_GREEN, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_CYAN, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_PINK, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_BLACK, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
		createThing(T_EFFECT, M_EFFECT_ANGEL_OF_DEATH, TRIBE_ORANGE, MAP_XZ_2_WORLD_XYZ(2, 0), false, false)
	end

	if (everyPow(1, 1)) then

		for i, ang in pairs(angels) do
			for i, sham in pairs(aliveShamans) do
				if (get_world_dist_xz(ang.Pos.D2, sham.Pos.D2) <= 1536) then
					if (ang.u.Pers ~= nil) then
						ang.u.Pers.Life = 0
					end
				end
			end

			local c2d = Coord2D.new()
			local c3d = Coord3D.new()
			MAP_XZ_2_WORLD_XYZ(2, 0, c3d)
			coord3D_to_coord2D(c3d, c2d)
			if (get_world_dist_xz(ang.Pos.D2, c2d) >= 14000) then
				if (ang.u.Pers ~= nil) then
					ang.u.Pers.Life = 0
				end
			end
		end
	end

	--Give enough mana for blast please
	GIVE_MANA_TO_PLAYER(TRIBE_BLUE, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_RED, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_YELLOW, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_GREEN, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_CYAN, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_PINK, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_BLACK, 668)
	GIVE_MANA_TO_PLAYER(TRIBE_ORANGE, 668)

	if (everyPow(60+G_RANDOM(240), 1)) then
		local lightsToShoot = {}

		local amountOfShots = G_RANDOM(12) + 1

		for i=1, amountOfShots do
			table.insert(lightsToShoot, LightningLocations[G_RANDOM(12) + 1])
		end

		for i, loc in pairs(lightsToShoot) do
			local foundShaman = 0

			SearchMapCells(SQUARE, 0, 0, 2, world_coord3d_to_map_idx(loc.Pos.D3), function(me)
				me.MapWhoList:processList(function(p)
					if (p.Type == T_PERSON) then
						if (p.Model == M_PERSON_MEDICINE_MAN) then
							createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, p.Pos.D3, false, false)
							foundShaman = 1
						end
					end
				return true
				end)
			return true
			end)

			if (foundShaman == 0) then
				createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, loc.Pos.D3, false, false)
			end
		end
	end

	if (everyPow(12, 1)) then
    for i, sham in pairs(aliveShamans) do
      if (sham ~= nil) then
        shamFindBools[sham.Owner] = 1
      end
    end

    for i=0, 7 do
      if (shamFindBools[i] == 0) then
        local sham  = getShaman(i)
        if (sham ~= nil) then
          table.insert(aliveShamans, sham)
        end
      end
    end

    shamFindBools = {[0]= 0, 0, 0, 0, 0, 0, 0, 0}
  end

	if (everyPow(1, 1)) then
    for i, sham in pairs(aliveShamans) do
      if (sham ~= nil and finishedGame == 0) then
        if (sham.State == S_PERSON_DYING or sham.State == S_PERSON_DROWNING or sham.State == S_PERSON_ELECTROCUTED or sham.State == S_PERSON_SWAMP_DROWNING) then
					if (sham.u.Pers.u.Owned.LastDamagedBy ~= TRIBE_NEUTRAL) then
						tribeKills[sham.u.Pers.u.Owned.LastDamagedBy] = tribeKills[sham.u.Pers.u.Owned.LastDamagedBy] + 1
					end
					
          table.remove(aliveShamans, i)

					for i, tribe in pairs(tribes) do
						if (tribe == sham.Owner and finishedGame == 0) then
							TrySpawn(tribe)
						end
					end
        end
      end
    end
  end

	--If someone reaches 20 kills the game ends.
	if (everyPow(36, 1)) then
		for i=0, 7 do
			if (tribeKills[i] >= 20) then
				local winnerTribe = i
				finishedGame = 1

				ProcessGlobalTypeList(T_PERSON, function(t)
					if (t.Owner ~= winnerTribe) then
						damage_person(t, winnerTribe, 90000, 1)
					end
					return true
				end)
			end
		end
	end

	--After 6 minutes the game ends.
	if (GetTurn() >= 4320 and finishedGame == 0) then
		local max_kills = -999999999
		local allKills = {}
		local winner = -1
		finishedGame = 1

		for i=0, 7 do
			table.insert(allKills, tribeKills[i])
		end

		for i,value in ipairs(allKills) do
			if (value > max_kills) then
				max_kills = value
				winner = i-1
			end
		end

		ProcessGlobalTypeList(T_PERSON, function(t)
      if (t.Owner ~= winner) then
        damage_person(t, TRIBE_NEUTRAL, 90000, 1)
      end
    return true
    end)
	end
end

function OnCreateThing(t)
	if (t.Type == T_SPELL) then
		for i, reinc in pairs(Reincarnations) do
			if (get_world_dist_xyz(reinc, t.Pos.D3) <= 2200) then
				t.Model = M_SPELL_NONE
			end
		end
	end

	if (t.Type == T_PERSON) then
		if (t.Model == M_PERSON_ANGEL) then
			table.insert(angels, t)
		end
	end
end

function TrySpawn(tribe)
	local spawnLocation = G_RANDOM(7) + 1
	local spawned = 0

	SearchMapCells(CIRCULAR, 0, 0, 8, world_coord3d_to_map_idx(Reincarnations[spawnLocation]), function(me)
		me.MapWhoList:processList(function(p)
			if (p.Type == T_PERSON) then
				if (p.Model == M_PERSON_MEDICINE_MAN) then
					spawned = 1
					return false
				end
			end
		return true
		end)
	return true
	end)

	if (spawned == 1) then
		TrySpawn(tribe)
	end

	if (spawned == 0) then
		createThing(T_PERSON, M_PERSON_MEDICINE_MAN, tribe, Reincarnations[spawnLocation], false, false)
	end
end

bar_w = 200
bar_h = 15
box_y_offset = 20
offset_incr = 30
names_offset = 40
function OnFrame()
	offset = 0
	for i=7, 0, -1 do
		PopSetFont(Font.Large)
		local scale = math.floor(ScreenHeight() * 0.01)
		local text_y_offset = 2 - math.ceil((bar_h/2)-2)
		DrawBox(ScreenWidth()-32-strings_name_width[i]-10, ScreenHeight()-box_y_offset-scale-offset, 25, bar_h+scale, Players[i].Color)
		LbDraw_Text(ScreenWidth()-strings_name_width[i] - 10, ScreenHeight()-box_y_offset-scale-text_y_offset-offset, Players[i].Name, 0)
		offset = offset + offset_incr
	end
end

function CachePlayerNameWidth(str, pn)
	local w = GetStringWidth(str)
	strings_name_width[pn] = w
end

function GetStringWidth(str)
	local w = 0;
	for i=1,#str,1 do
		local c = str:sub(i,i)
		c = string.upper(c);
		if (char_width[c] ~= nil) then
			w = w + char_width[c];
		else
			w = w + 10 + 2;
		end
	end
	return w;
end