import(Module_System)
import(Module_PopScript)
import(Module_Game)
import(Module_Globals)
import(Module_Players)
import(Module_Map)
import(Module_Person)
import(Module_Objects)
import(Module_Table)
import(Module_Draw)
import(Module_DataTypes)
import(Module_Level)
import(Module_Math)
import(Module_String)
import(Module_Sound)

include("TextMsg.lua");

log("Script is loading...")

local gs = gsi();
local gns = gnsi();

local player_nums = {}
local player_names = {}
local player_info ={
  {"",0,4,887,false},
  {"",1,4,914,false},
  {"",2,4,941,false},
  {"",3,4,968,false},
  {"",4,4,1623,false},
  {"",5,4,1650,false},
  {"",6,4,1677,false},
  {"",7,4,1704,false}
}

local game_state = 0
local round_time = 720*5
local init_turn = gs.Counts.ProcessThings
local message_delay = 48
local mi = 1
local ready_time = 12*20;
local tut_messages = {
  "Welcome to the disco floor minigame.",
  "Your objective is to stand on the correct colored sparkle once the timer ticks 0.",
  "Each round will act faster and You have to react faster also.",
  "If You stood on the wrong color, it'll take 1 point, while standing on correct will grant You 1.",
  "Let the last shaman dancing win!"
}
local read_me_text = "Welcome to the disco floor minigame. Your objective is to stand on the correct colored sparkle once the timer ticks 0. Each round will act faster and You have to react faster also. If You stood on the wrong color, it'll take 1 point, while standing on correct will grant You 1."

local welcomeBox = TextBox:Create(0, 0, 320, 240);
welcomeBox:FormatString(read_me_text);
welcomeBox:SetHeaderText("Disco Floor");

local round = 1
local round_react_time = 120
local round_aftermath_time = 120
local round_reappear_time = 12
local max_rounds = 50

local spark_a_clrs = {2,-2,3,1,10,11,12,-1}
local color_idxes = {2,-2,3,1,10,11,12,-1,0}
local color_idxes_names = {"Blue","Red","Yellow","Green","Lightblue","Purple","Black","Orange","White"}
local thing_buffer = {}
local pattern_color_codes = {
  [1] = {2,-2,3},
  [2] = {-1,1,11},
  [3] = {1,0,10,12},
  [4] = {-1,-2,2,3,0},
  [5] = {10,-1,-2,0},
  [6] = {10,11,12,-1,0,1},
  [7] = {0,12},
  [8] = {10,2,1,11},
  [9] = {10,1,3},
  [10] = {0}
}
local pattern_buffer = {
  [1] = {2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2,
         2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2,
         2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,-2,-2,-2,2,2,2,3,3,3,2,2,2,-2,-2,-2,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         3,3,3,-2,-2,-2,-2,-2,-2,2,2,2,2,2,2,2,2,2,2,2,2,-2,-2,-2,-2,-2,-2,3,3,3,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         -2,-2,-2,2,2,2,3,3,3,-2,-2,-2,3,3,3,3,3,3,-2,-2,-2,3,3,3,2,2,2,-2,-2,-2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         2,2,2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,-2,-2,-2,2,2,2,2,2,2,2,2,2,
         2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2,
         2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2,
         2,2,2,2,2,2,-2,-2,-2,3,3,3,-2,-2,-2,-2,-2,-2,3,3,3,-2,-2,-2,2,2,2,2,2,2},
  [2] = {-1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,11,11,11,1,1,1,-1,-1,-1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,
         -1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1,
         -1,-1,-1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,-1,-1},
  [3] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
         1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
         12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,10,10,0,0,0,1,1,1,
         12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,10,10,0,0,0,1,1,1,
         0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,10,10,0,0,0,1,1,1,
         12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,
         0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,
         12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,1,1,1,
         0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
         10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,0,1,1,1,
         0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,0,1,1,1,
         10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,0,1,1,1,
         0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,0,1,1,1,
         10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,0,1,1,1,
         0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,0,1,1,1,
         10,0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,0,1,1,1,
         0,10,0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,0,1,1,1,
         10,0,10,0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,0,1,1,1,
         0,10,0,10,0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,0,1,1,1,
         10,0,10,0,10,0,10,0,10,0,10,0,10,0,10,0,12,0,12,0,12,0,12,0,12,0,12,1,1,1},
  [4] = {0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,-1,-1,0,0,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         -2,-2,-1,-1,-2,-2,-1,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,-2,-2,-1,-1,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,
         2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,
         2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,-1,-1,2,2,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,
         3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3,-1,-1,3,3},
  [5] = {10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10,
         10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10,
         10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         -1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         10,10,10,-2,-2,-2,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-2,-2,-2,10,10,10,
         10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10,
         10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10,
         10,10,10,10,10,10,-1,-1,-1,0,0,0,-1,-1,-1,-1,-1,-1,0,0,0,-1,-1,-1,10,10,10,10,10,10},
  [6] = {12,12,12,12,12,12,12,12,12,12,12,12,12,12,0,0,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,12,12,12,12,12,0,0,0,0,11,11,11,11,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,12,12,12,12,0,0,1,1,0,0,11,11,11,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,12,12,12,0,0,0,1,1,0,0,0,11,11,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,12,12,0,0,0,0,0,0,0,0,0,0,11,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,11,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,12,0,0,0,0,0,0,1,1,0,0,0,0,0,0,11,11,11,11,11,11,11,11,
         12,12,12,12,12,12,12,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,11,11,11,11,11,11,11,
         12,12,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,11,11,11,11,11,
         12,12,12,12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,11,11,11,11,
         12,12,12,12,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,11,11,11,11,
         12,12,12,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,11,11,11,
         12,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,11,
         12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,
         0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,
         0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,
         10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,
         10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,
         10,10,10,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,
         10,10,10,10,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,
         10,10,10,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,0,0,0,0,0,0,1,1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,10,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,10,10,0,0,0,1,1,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,10,10,10,0,0,1,1,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,10,10,10,10,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
         10,10,10,10,10,10,10,10,10,10,10,10,10,10,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
  [7] = {12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12,
         12,12,12,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,0,0,0,12,12,12,12,12,12,12,12,12},
  [8] = {10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10,
         10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10,
         10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,1,1,1,1,1,1,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         2,2,2,1,1,1,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,1,1,1,2,2,2,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,10,10,10,10,10,10,10,10,10,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         2,2,2,2,2,2,10,10,10,1,1,1,1,1,1,1,1,1,1,1,1,10,10,10,2,2,2,2,2,2,
         10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10,
         10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10,
         10,10,10,2,2,2,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,10,10,10,2,2,2,10,10,10},
  [9] = {10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,
         10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,
         10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,
         10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,
         1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,1,1,10,1,1,
         1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,1,10,1,1,10,10,1,1,10,1,
         10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10,10,1,1,10,3,3,10,1,1,10},
  [10] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
}

for i=0,7 do
  if (gs.Players[i].DeadCount == 0) then
    local n = get_player_name(i,true)
    player_info[i+1][1] = n
    table.insert(player_nums,i)
    table.insert(player_names,n)
    SET_NO_REINC(i,1)
  else
    --Dead or inactive player (bugged?)
    set_player_name(i,"NOPLAYER",true)
    table.insert(player_names,"NOPLAYER")
    player_info[i+1][1] = "NOPLAYER"
    player_info[i+1][3] = -1
  end
end

local spell_info = spells_type_info()
spell_info[17].Cost = 100
spell_info[17].OneOffMaximum = 2
spell_info[17].WorldCoordRange = 2048
local imp_coord = MAP_XZ_2_WORLD_XYZ(16,132)
centre_coord3d_on_block(imp_coord)

local function reg_square_offset(c3d,r,_TABL)
  local mapXZ = MapPosXZ.new()
  mapXZ.Pos = world_coord3d_to_map_idx(c3d)
  mapXZ.XZ.X = mapXZ.XZ.X
  mapXZ.XZ.Z = mapXZ.XZ.Z
  local x = 0
  local z = 0
  local count = 0
  for i=0,r do
    x = mapXZ.XZ.X + i*2
    for i=0,r do
      z = mapXZ.XZ.Z + i*2
      local c3d_local = Coord3D.new()
      c3d_local = MAP_XZ_2_WORLD_XYZ(x,z)
      centre_coord3d_on_block(c3d_local)
      local zone_trail = createThing(6,8,8,c3d_local,false,false)
      zone_trail.DrawInfo.DrawNum = 1293
      zone_trail.DrawInfo.Flags = zone_trail.DrawInfo.Flags | (1<<4)
      --zone_trail.u.Effect.Duration = -1
      zone_trail.Pos.D3.Ypos = zone_trail.Pos.D3.Ypos - 192
      table.insert(_TABL,zone_trail)
      local me = world_coord3d_to_map_ptr(c3d_local)
      --is spot walkable?
    end
  end
end

local function toggle_player_spell(_pn,_spell,_arg)
  local ref = gs.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable
  if (_arg) then
    gs.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable = ref | (1 << _spell)
  elseif (not _arg) then
    gs.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable = ref ~ (1 << _spell)
  end
end

reg_square_offset(imp_coord,29,thing_buffer)

display_value = 0
draw_code = 0
local has_proccessed = false
local has_given_color = false
local color_to_stand_on = 0
local display_color = "None"

local function find_color_name(clr_code)
  for i,CLR in ipairs(color_idxes) do
    if (clr_code == CLR) then
      display_color = color_idxes_names[i]
      break
    end
  end
end

local function update_floor_color(pattern_idx)
  for i,t in ipairs(thing_buffer) do
    t.DrawInfo.Alpha = pattern_buffer[pattern_idx][i]
    t.DrawInfo.Flags = t.DrawInfo.Flags ~ (1<<4)
  end
end

local function hide_floor()
  for i,t in ipairs(thing_buffer) do
    t.DrawInfo.Flags = t.DrawInfo.Flags | (1<<4)
  end
end

local function take_score(pn)
  for i in ipairs(player_info) do
    if (player_info[i][2] == pn) then
      if (player_info[i][3] == 1) then
        player_info[i][3] = player_info[i][3] - 1
        player_info[i][5] = true
      end
      if (player_info[i][3] > 0) then
        player_info[i][3] = player_info[i][3] - 1
      end
      break
    end
  end
end

local function process_shamans_standings(clr)
  for i=0,7 do
    local s = getShaman(i)
    if (s ~= nil) then
      local me = world_coord3d_to_map_ptr(s.Pos.D3)
      me.MapWhoList:processList(function(t)
        if (t.Type == 6) then
          if (t.Model == 8) then
            if (t.DrawInfo.DrawNum == 1293) then
              if (t.DrawInfo.Alpha ~= clr) then
                take_score(s.Owner)
                if (gns.PlayerNum == s.Owner) then
                  queue_sound_event(nil,SND_EVENT_SHAMAN_DIE,(1<<0));
                end
                return false
              end
            end
          end
        end
        return true
      end)
    end
  end
end

local function check_dead_players()
  for i in ipairs(player_info) do
    if (player_info[i][5]) then
      local s = getShaman(player_info[i][2])
      if (s ~= nil) then
        damage_person(s,8,65535,1)
      end
    end
  end
end

function OnTurn()
  if (gs.Counts.ProcessThings > init_turn + 36) then
    if (game_state == 0) then
      if (gs.Counts.ProcessThings > init_turn + 36) then
        if (ready_time > 0) then
          ready_time = ready_time - 1;
        else
          -- for i,pn in ipairs(player_nums) do
          --   createThing(7,49,8,player_spawn_coord[i],false,false)
          --   toggle_player_spell(pn,2,true)
          -- end
          game_state = 1
        end
        -- if (mi <= #tut_messages) then
        --   log_msg(8,tut_messages[mi])
        --   mi = mi+1
        -- else
        --   for i=0,7 do
        --     if (gs.Players[i].DeadCount == 0) then
        --       toggle_player_spell(i,17,true)
        --     end
        --   end
        --   game_state = 1
        -- end
      end
    elseif (game_state == 1) then
      if (round < max_rounds) then
        if (round_react_time > 0) then
          if (not has_given_color) then
            has_given_color = true
            local idx = G_RANDOM(#pattern_buffer-1)+1
            update_floor_color(idx)
            color_to_stand_on = pattern_color_codes[idx][G_RANDOM(#pattern_color_codes[idx])+1]
            find_color_name(color_to_stand_on)
            draw_code = 1
          end
          display_value = round_react_time
          round_react_time=round_react_time-1
        elseif (round_react_time==0) then
          if (not has_proccessed) then
            process_shamans_standings(color_to_stand_on)
            check_dead_players()
            has_proccessed = true
          end
          draw_code = 2
          hide_floor()
          display_value = round_aftermath_time
          if (round_aftermath_time > 0) then
            round_aftermath_time=round_aftermath_time-1
          elseif(round_aftermath_time==0) then
            has_given_color = false
            has_proccessed = false
            round = round+1
            round_react_time = 84-round
            round_aftermath_time=120-(round*2)
          end
        end
      end
    end
  end
end

--[[ took this piece of code from here coz i was lazy to write one myself
https://gist.github.com/jesseadams/791673
]]
local function SecondsToClock(seconds)
  local seconds = tonumber(seconds)

  if seconds <= 0 then
    return "00:00:00";
  else
    hours = string.format("%02.f", math.floor(seconds/3600));
    mins = string.format("%02.f", math.floor(seconds/60 - (hours*60)));
    secs = string.format("%02.f", math.floor(seconds - hours*3600 - mins *60));
    return hours..":"..mins..":"..secs
  end
end

function OnFrame()
  local gui_width = GFGetGuiWidth();
  if (game_state == 0) then
    PopSetFont(3);
    local seconds = math.floor(ready_time/12);
    local str = string.format("Game Starts In: %i seconds", seconds);
    LbDraw_Text((math.floor(ScreenWidth() / 2) - math.floor(string_width(str) / 2)) + math.floor(gui_width / 2), ScreenHeight() - 32, str, 0);
    welcomeBox:Render();
  end
  if (game_state == 1) then
    if (round_time > 0) then
      PopSetFont(3)
      local w = ScreenWidth()
      local h = ScreenHeight()
      --local ticks_to_seconds = math.floor(round_time/12)
      LbDraw_Text(w-128,16,"Round: " .. round .. "/" .. max_rounds,0)
      if (display_value ~= nil) then
        PopSetFont(9)
        local str_cd = "";
        if (draw_code == 1) then
          str_cd = string.format("Time - %i", display_value);
          LbDraw_Text((math.floor(ScreenWidth() / 2) - math.floor(string_width(str_cd) / 2)) + math.floor(gui_width / 2),math.floor(h/2),str_cd,0)
          str_cd = string.format("Color to stand - %s", display_color);
          LbDraw_Text((math.floor(ScreenWidth() / 2) - math.floor(string_width(str_cd) / 2)) + math.floor(gui_width / 2),math.floor(h/2)+24,str_cd,0)
        elseif(draw_code==2) then
          str_cd = string.format("Time - %i", display_value);
          LbDraw_Text((math.floor(ScreenWidth() / 2) - math.floor(string_width(str_cd) / 2)) + math.floor(gui_width / 2),math.floor(h/2),str_cd,0)
          str_cd = "Get Ready!";
          LbDraw_Text((math.floor(ScreenWidth() / 2) - math.floor(string_width(str_cd) / 2)) + math.floor(gui_width / 2),math.floor(h/2)+24,str_cd,0)
        end
      end
    end
    for i,num in ipairs(player_info) do
      local id = player_info[i][2]
      local name = player_info[i][1]
      local w = ScreenWidth()
      local h = ScreenHeight()
      if (w <= 800 and h <= 600) then
        PopSetFont(4)
        LbDraw_Sprite(w-178,(h-30)-(i*12), get_sprite(0,player_info[i][4]))
        LbDraw_Text(w-168,(h-32)-(i*12),"" .. name,0)
        LbDraw_Text(w-88,(h-32)-(i*12),"   : " .. player_info[i][3],0)
      else
        PopSetFont(3)
        LbDraw_ScaledSprite(w-246,(h-30)-(i*16), get_sprite(0,player_info[i][4]),12,12)
        LbDraw_Text(w-228,(h-32)-(i*16),"" .. name,0)
        LbDraw_Text(w-108,(h-32)-(i*16),"   : " .. player_info[i][3],0)
      end
    end
  end
end

log("Script loaded!")
